<?php
// v0.10
// see class_c64reader.php for more info

class LbrImage
{
	var $imagefile = "";
	var $num_entries = 0;
	var $error = "";
	var $signature = "";
	var $entries = array();

	function LbrImage(&$image)
	{
		$this->imagefile = $image;   
    $this->signature = strtok($image, " "); 

    if ($this->signature<>"DWB")
    {
			$this->error = "Invalid header in LBR file - signature not found!";
			return;
    }

    $this->num_entries  = strtok("\r");   

    for ($i=0 ; $i < $this->num_entries ; $i++)
    {
      $entry = array();
      
      $entry["filename"]  = strtok("\r");
      $entry["filetype"]  = strtok("\r");
      $entry["filesize"]  = strtok("\r");
      $this->entries[]      = $entry;
    }
    
    $offset = strlen($image) - strlen(strtok(""));
    for ($i=0 ; $i < $this->num_entries ; $i++)
    {
      $this->entries[$i]["start"]    = $offset;
      $this->entries[$i]["end"]      = $offset + $this->entries[$i]["filesize"];
      $this->entries[$i]["filedata"] = substr($image, $this->entries[$i]["start"], $this->entries[$i]["filesize"]);      
      $this->entries[$i]["error"]    = ($this->entries[$i]["end"] > strlen($image)) ? 'error' : '';
      $this->error                   = $this->entries[$i]["error"] ? 'Error' : '';
      $offset                       +=  $this->entries[$i]["filesize"];
    }
  }
}
?>
