<?php
// v0.10
// see class_c64reader.php for more info

class SpyImage
{
	var $imagefile = "";
	var $num_entries = 0;
	var $error = "";
	var $signature = "";
	var $entries = array();

	function SpyImage(&$image)
	{
		$this->imagefile = $image;   
    
    $offset = 3810; // $0EE2, self extracting code
    $lfm    = 255;  // Last File Marker, == 0 then end of dir found
    $dir_count = 0; // Check for new dir-block
    
    while ($lfm<>0)
    {
      $entry = array();
      $dir_count++;
      $u = unpack("Cfiletype", substr($image, $offset, 1));
      $entry["filetype"] = $u["filetype"];
      $entry["filename"]  = substr($image, $offset+3, 16);
      $u = unpack("vchksum/Clsu/Clfm/Cunk/vfcc", substr($image, $offset+23, 7));
      $entry["filesizeblocks"]  = $u["fcc"];
      $entry["filesize"]  = $u["fcc"] * 254 + - 255 + $u["lsu"];
      $lfm   = $u["lfm"];
      $this->entries[]      = $entry;
      $this->num_entries++;
      $offset += 32;
      if ($dir_count==8)
      {
        $dir_count = 0;
        $offset    -= 2;
      }
    }
    

    $offset = 254*ceil($offset/254);
    for ($i=0 ; $i < $this->num_entries ; $i++)
    { 
      $this->entries[$i]["start"]    = $offset;
      $this->entries[$i]["end"]      = $offset + $this->entries[$i]["filesize"];
      $this->entries[$i]["filedata"] = substr($image, $this->entries[$i]["start"], $this->entries[$i]["filesize"]);
      $this->entries[$i]["error"]    = ($this->entries[$i]["end"] > strlen($image)) ? 'error' : '';
      $this->error                   = $this->entries[$i]["error"] ? 'Error' : '';
 
      $offset += $this->entries[$i]["filesizeblocks"] * 254;
    }
  }
}
?>
