<?php
// v0.10
// see class_c64reader.php for more info

class X64Image
{
	var $imagefile = "";
	var $num_entries = 0;
	var $error = "";
	var $signature = "";
	var $entries = array();

	function X64Image(&$image)
	{
		$this->imagefile = $image;   
    if ( ($image[0]<>"\x43") OR ($image[1]<>"\x15") OR 
         ($image[2]<>"\x41") OR ($image[3]<>"\x64") )
    {
  			$this->error = "This file does not have a x64 signature!";
        return;
    }

    $u = unpack("Cversion/Csubversion/Cdevice", substr($image, 4, 3));
    $device = $u["device"];

    /* Device translation table
      $00=1540, $01=1541, $02=1542, $03=1551, $04=1570, $05=1571, $06=1572
      $08=1581, $10=2031,4031     , $11=2040,3040     , $12=2041, $18=4040
      $20=8050, $21=8060, $22=8061, $30=SFD-1001      , $31=8250, $32=8280
    */
    
    if ( ($device==1) OR ($device==5) OR ($device==8) ){
      $this->imagefile = substr($image, 64, strlen($image));    
    }
    else{
  		$this->error = "Device is currently not supported!";
    }
    
  }
}
?>
