<?php
// Useful functions 
    function ignorecasesort(&$array) {
     $separator="|<>|";
     for($i=0;$i<sizeof($array);$i++) { $array[$i]=strtolower($array[$i]).$separator.$array[$i]; }
     sort($array);
     for($i=0;$i<sizeof($array);$i++) { $t=$array[$i]; $t=explode($separator,$t); $array[$i]=$t[1]; }
    }  

    function getmicrotime(){
      list($usec, $sec) = explode(" ",microtime());
      return ((float)$usec + (float)$sec);
    }
    
    function HTML_code($c64filename){
      return str_replace(array('_', '>' ,'<', '^', chr(92), chr(129), chr(147), chr(152), chr(154), chr(192), chr(96), chr(145), chr(158), chr(28), chr(150), chr(186), chr(125), chr(211), chr(221), chr(195), chr(18) ), array('&larr;','&gt;','&lt;', '&uarr;', '&pound;', '&spades;', '&hearts;', '&clubs;', '&diams;', '&mdash;', '&mdash;', '&#149;', '&pi;', '&pound;', '&#x2716;', '&#x2713;', '&#124;', '&hearts;', '|&nbsp;', '-', 'R'), $c64filename);
    }    
    
    
    function replace_bad_chars($str){
      // remove illegal & "bad" chars from filename.
      return trim(str_replace(array('"', '\\', chr(20),chr(00),chr(1),chr(17),chr(160),chr(14) ),' ',$str));
    }    
    
              
    function get_raw_data($filename){
      if (is_file($filename)){
        $fp = fopen($filename,'r');
        if ($fp===false){
          echo "Error opening file: $filename <br>";
          $raw_data = NULL;
        }
        else {
          $file_size = filesize($filename);  
          $raw_data  = fread($fp, $file_size);
          fclose($fp);  
        }        
      } else {
        $raw_data = NULL;
      }
      return $raw_data;      
    }
    
    
      function get_error_color($error_nr){
      switch($error_nr){
        case "1" : return "lightgreen"; break;
        case "2" : return "red"; break;
        case "3" : return "lightblue"; break;
        case "4" : return "blue"; break;
        case "5" : return "yellow"; break;
        default  : return "lightyellow";
        }
      }


    function match_name_fix($str){
      return strtoupper(preg_replace(array('/\s\#/', '/\s\+/'), array('#','+'), $str));
    }    
    
    
    function entry_name_fix($str){
      $str = trim(str_replace('"', "'", $str));
      return preg_replace(array('/\[/', '/\]/', '/\>/', '/\</', '/\(/', '/\)/', '/\+/', '/\?/', '/\*/', '/\$/'  ), array('\[', '\]', '\>', '\<', '\(', '\)', '\+', '\?', '*', '\\\$' ), $str); 
    }    
    
    
    function reduce_entry_name($file_entry){
      $c64_filename = str_replace(array(chr(0), chr(160), "'"),' ',$file_entry);  // pc64 format thing...
      //remove spaces to get better hit i.e. "DEMO       /ABC" => "DEMO/ABC"      
      $c64_filename = preg_replace('/\s\s+/', ' ', $c64_filename);   
      $c64_filename = preg_replace(array('/\/\s/', '/\s\//'), '/', $c64_filename);    //  " /" -> "/", "/ " -> "/"
      // Remove spaces
      $c64_filename = preg_replace(array('/\s\[/', '/\s\(/', '/\s\</', '/\.+/', '/\s\+/', '/\s\{/', '/\s\#/'), array('[','(','<','.','+','{','#'), $c64_filename); 
      // $c64_filename = trim($c64_filename, "'");                      // "'filename'" -> "filename", just to get better hits!
      return trim($c64_filename);
    }  


   function is_az($str, $pos, $len)
   {
     // this function decides weather there is a LETTER [A..Z] to the
     // left or right of last found groub-abbrivation! 
     
     $LETTER_A = 64; // ord("A")-1
     $LETTER_Z = 91; // ord("Z")+1
     $result = false;

     $val = ord($str[$pos]);
     if ( ($val<=$LETTER_A) OR ($val>=$LETTER_Z)){
      $result = false;
     }        
     else {
      if ($pos>0){
        $val = ord($str[$pos-1]);
        if ( ($val>$LETTER_A) AND ($val<$LETTER_Z) ){
          $result = true;
        }
      }
      if(!$result){
       $pos += $len;
       if (($pos)<strlen($str)){
         $val = ord($str[$pos]);
         if ( ($val>$LETTER_A) AND ($val<$LETTER_Z) ){
          $result = true;          
         }
        }
      }
     }
     return $result;
   }


    function check($long,$short){
      if ( (strlen($short)<=strlen($long)) AND (strlen($short)>0) )
      {
        $short = trim(preg_replace('/\s\s+/', ' ', $short));   
        $long = trim(preg_replace('/\s\s+/', ' ', $long));   
        $short = ltrim($short,".");

        $l = 0;   // offset long  string
        $s = 0;   // offset short string
        $rem = 0; // position to beginning of token (long)
        $r = "";  // result 
        while ( ($s<(strlen($short))) AND ($l<(strlen($long)))) 
        {
          // copy current char while equal, and increment all indeces
          if ($long[$l]==$short[$s]){
              $r.=$short[$s];$l++;$s++;$rem++;
              # echo "<br>1:".$r;
          }                    
          // else if abbreviation found "."/" " : "str.fighter" / "S FIGHTER"
          else if ( ($short[$s]=='.') OR ($short[$s]==' ') OR ($short[$s]=='&') ) {              
              $r .= $short[$s];
              # echo "<br>2:".$r;
              $s++; 
              if ( ($s<(strlen($short))) AND ($short[$s]==' ') ){$s++;} // increase s till next char
              $next = strpos($long, ' ', $l);   // get position to next space, if it exists
              if (!($next===false)) {
                  // There is a next SPACE, increase l to next+1, and reset rem
                  $l=$next+1;$rem = 0;
              }                      
          }                     
          // not equal "a"<>"b", STOP!
          else {
              $s = strlen($short);               // stop the while loop.
              # $r = substr($r,0,strlen($r)-$rem); // remove nonmatching token
              $r = substr($r,0,strlen($r)); // remove nonmatching token
              # echo "<br>3:".$r;
          }
        }
        // $r .= substr($long, $l, $s-$r); // ensure result contains non matching tail
        $r .= substr($long, $l, strlen($long)); // ensure result contains non matching tail
        # echo "<br>4:".$r;
        }
        else
        {
          $r = $long; // if short>long, then return long.
          # echo "<br>5:".$r;  
        } 
        # echo "<br>";
        return $r;
   }
   
  function virus_infected(&$data){
    global $Lvirus_signatures;
    foreach ($Lvirus_signatures as $name=>$virus){
      if (strpos($data, $virus)){
        return $name; 
      }  
    }
    return null;
  }
   
  function is_unformated_d64($media_md5) {
    return ($media_md5=='2af65733f879e7a724ca51d5ce3efb59') ? true : false;
  }   
   
  function insert_html_br($count){
    for ($i=0;$i<$count;$i++){echo "<br>";}  
  } 

  function get_sysline(&$data_entry, $basic_length=200){
    global $Lbasic_num, $Lbasic_val;
    // check that we have a C64 - BASIC begin in $0801 => SYS may exist!  
    $data = substr($data_entry, 0, $basic_length);
    $u = @unpack("vstart", substr($data, 0, 2));
    $entry_sysline = " ";
    if ($u["start"]==2049)
    {
      # [start ]: addr of basic line begin
      # [length]: of current basic line
      # Search hex-code(#$9E) for BASIC command "SYS"
      $k = strpos($data, ''); 
      if ( ($k<$basic_length) && ($k>0) )  {
        $end_basic = strpos($data, chr(0).chr(0).chr(0)) - 1;
        # if no BASIC end is found in substring(data), then set it to max.
        if ($end_basic==-1){ $end_basic = strpos($data, chr(0)) - 1; }
        $pos = 2;       # start position of BASIC CODE
        $basic_entry = 0; # count current basic line-numbers
        while ( ($pos<$end_basic) && ($basic_entry<2) ){
          $u = @unpack("vEndadr/vLine", substr($data, $pos, 4));                
          $token = strtok(substr($data, $pos+4, $basic_length), chr(0));
          $delete_pos = strpos($token, chr(20), 0);
          while ($delete_pos>0){
           # DEL pressed - so delete last char of sysline and skip this char
           $token = substr($token,0,$delete_pos-1) . substr($token,$delete_pos+1,strlen($token)+1);
           $end_basic--;
           $delete_pos = strpos($token, chr(20), 0);
          }
          $entry_sysline .= $u["Line"] . ' ' . str_replace($Lbasic_num, $Lbasic_val, $token) . ' ';
          $basic_entry++;
          $pos += strlen($token) + 5;
        }
      }
    }
    return $entry_sysline;
  }
     
  function get_load_adr(&$data){
   if (strlen($data)>1) {
     $u = unpack("vloadadr", substr($data, 0, 2));
     return '$' . str_pad(dechex($u['loadadr']), 4, '0', STR_PAD_LEFT);
   } else {return False;} 
  }
  
    
?>