<?php
set_time_limit(0);  // no time limit to finish script!
require_once('config.php');
echo $html_begin;

if (!empty($_REQUEST['reset']))
{
  $DB->kill_database();
  $DB->create_db_structure();  
  echo "<h2>All data was erased and system is now reset to default!</h2>";
  echo "<form name='form' action='help.php' method='POST'><br><input type='submit' value='Ok'></form>";
  exit;  
}

if (!empty($_REQUEST['import_comments']))
{
  $target_path = '' . basename( $_FILES['import_file_name']['name']); 
  if(!move_uploaded_file($_FILES['import_file_name']['tmp_name'], $target_path)) 
  {
    echo "There was an error uploading the file to server, please try again!";
  }
  
  $import_file  = file($target_path);
  $num_imported = 0;
  for ($i=0;$i<sizeOf($import_file);$i++)
  {
    $line = $import_file[$i];
    $media_md5  = trim(strtok($line, "|"));   
    $file_entry = trim(strtok("|"));   
    $file_size  = trim(strtok("|"));   
    $comment    = trim(strtok(""));
    $val = $DB->import_comments($media_md5, $file_entry, $file_size, $comment);
    $num_imported = $num_imported + $val;
  }
  unlink($target_path);
  echo "<br><b>$num_imported of ".sizeOf($import_file)." comments was imported!</b>";
  echo "<form name='form' action='help.php' method='POST'><br><input type='submit' value='Ok'></form>";
  exit;
}


echo "<FIELDSET style='width:500px;'><legend><b>Help</b></legend>";
echo "<a name='top' id='top' href='#'></a>";
echo "<fieldset><legend><b>Quick menu</b></legend>";
echo "<i>-information and help</i><br><br>";
echo "<a name='begin' id='begin' href='#'></a>";
echo "On this page you will find information on how to use PreserveDBC64<br>";
echo "and explanations of various issues and questions that may come<br><br>";
echo "<ul>";
echo "<li><a class='menu' href='#search'>How to use Search</a></li><br>";
echo "<li><a class='menu' href='#emulator'>C64 Emulator</a></li><br>";
echo "<li><a class='menu' href='#errorcodes'>Error codes explained</a></li><br>";
echo "<li><a class='menu' href='#comments'>Import comments from SearchDBC 1.x</a></li><br>";
echo "<li><a class='menu' href='#reset'>Reset system</a></li><br>";
echo "</ul>";
echo "</fieldset><br><br>";


echo "<a name='search' id='search' href='#'></a>";
echo "<fieldset><legend><b>Search</b></legend>";
echo "<img src='help/search_1.png'>";
echo "<table>";
echo "<th>Search type</th><th>Description</th>";
echo "<tr><td>Filename</td><td>Filename of C64 file</td></tr>";
echo "<tr><td>Sysline</td><td>SYSLINE that starts a basic/machinecode program</td></tr>";
echo "<tr><td>Label</td><td>Label search of any format having a label</td></tr>";
echo "<tr><td>BAM</td><td>Hidden infomation in Block Availability Map</td></tr>";
echo "<tr><td>Data (md5)</td><td>Search for data with given md5 value</td></tr>";
echo "<tr><td>Show Similar</td><td>Enable/disable showing similar disks. It will slowdown searching!</td></tr>";
echo "</table>";

echo "<table>";
echo "<th>Search field</th><th>Description</th>";
echo "<tr><td>Text field</td><td>Type the text you want to search for using  as wild card. fx. 'RAMBOABC' </td></tr>";
echo "</table>";

echo "<table>";
echo "<th>Filetype</th><th>Description</th>";
echo "<tr><td>All</td><td>Search all filetypes</td></tr>";
echo "<tr><td>PRG</td><td>Program</td></tr>";
echo "<tr><td>DEL</td><td>Del....</td></tr>";
echo "<tr><td>SEQ</td><td>Sequential</td></tr>";
echo "<tr><td>USR</td><td>User...</td></tr>";
echo "</table>";

echo "<table>";
echo "<th>Filessize</th><th>Description</th>";
echo "<tr><td>Text field</td><td>Type the number of Blocks that must match the search</td></tr>";
echo "</table>";

echo "</fieldset><br><br>";


echo "<a name='emulator' id='emulator' href='#'></a>";
echo "<fieldset><legend><b>C64 Emulator</b></legend>";
echo "I recommend VICE: <a target='_BLANK' href='http://www.viceteam.org'>www.viceteam.org</a><br><br><br>";
echo "<img src='help/vice.png'>";
echo "</fieldset><br><br>";


echo "<a name='errorcodes' id='errorcodes' href='#'></a>";
echo "<fieldset><legend><b>Error Codes explained</b></legend>";
echo "<table>";
echo "<th>Error code</th><th>Info</th>";
echo "<tr><td>0</td><td>No errors found</td></tr>";
echo "<tr><td>1</td><td>Invalid track/sector pointer (out of bounds)</td></tr>";
echo "<tr><td>2</td><td>Cyclic data found (no end of data found...)</td></tr>";
echo "<tr><td>4</td><td>Directory off track (no directory)</td></tr>";
echo "<tr><td>8</td><td>No track/sector with end marker found</td></tr>";
echo "<tr><td>16</td><td>Error bytes found on D64</td></tr>";
echo "</table>";
echo "<i>Notice that it is the binary values of 5 bits!<br>";
echo "As you can have errors ranging over multiple error codes</i><br>";
echo "</fieldset><br><br>";

echo "<a name='comments' id='comments' href='#'></a>";
echo "<fieldset><legend><b>Import comments from SearchDBC v1.x</b></legend>";
echo "<form name='form_comments' action='help.php' method='POST' enctype='multipart/form-data'>";
echo "Please note that not all comments will be imported from version 1.x to <br>";
echo "PreserveC64DB due to the difference in how filenames are added.<br>";
echo "Version 1.x include all filename regardless of existance in archive. <br>";
echo "PreserveC64DB only include filenames that have some data attached.<br><br>";
echo "<b>Import</b> comments from SearchDBC v.1.x. Chose file:<input type='file' name='import_file_name'>";
echo "<input type='submit' name='import_comments' Value='Import'>";
echo "</form>";
echo "</fieldset><br><br>";


echo "<a name='comments' id='reset' href='#'></a>";
echo "<fieldset><legend><b>Reset database system</b></legend>";
echo "<form name='form_reset' action='help.php' method='POST'>";
echo "<b>Beware - all data will be erased from database!</b><br><br>";
echo "<input type='submit' name='reset' Value='Reset'>";
echo "</form>";
echo "</fieldset>";

echo "</FIELDSET>";
insert_html_br(30);
echo $html_end;
?>
