<?php
set_time_limit(0);  // no time limit to finish script!
require_once("config.php");
ob_start();

$import_btn = (!empty($_REQUEST['import_btn'])) ? $_REQUEST['import_btn'] : null;
$update_btn = (!empty($_REQUEST['update_btn'])) ? $_REQUEST['update_btn'] : null;
$sel_coll_upd = (!empty($_REQUEST['sel_coll_upd'])) ? $_REQUEST['sel_coll_upd'] : null; 
$sel_coll = (!empty($_REQUEST['sel_coll'])) ? $_REQUEST['sel_coll'] : null; 
$coll_name  = ($import_btn) ? $sel_coll : $sel_coll_upd;  

$skipped_files = 0;
$imported_new_files = 0;
$imported_existing_files = 0;
$imported_unformated = 0;
$imported_new_files_not_supported = 0;

# Function that traverses all dirs and import data to database
   function traversedir($dir, &$coll_id, &$os_id) 
   {
    global $DB;
    global $Lskip_ext;
    global $skipped_files;
    global $imported_new_files;
    global $imported_existing_files;
    global $imported_unformated;
    global $imported_new_files_not_supported;
    
    $dir_list = scandir(ARCHIVE_PATH.$dir);
    ignorecasesort($dir_list);     

    for ($i=0;$i<sizeOf($dir_list);$i++)
    {
      if ($dir_list[$i] != "." && $dir_list[$i] != "..") 
      {
        $file_entry = ARCHIVE_PATH . $dir . $dir_list[$i]; 
        
        if (is_dir($file_entry)) 
        {
          traversedir($dir . $dir_list[$i].'/', $coll_id, $os_id);
        }
        else if (is_file($file_entry)) 
        {
          $file_extension = strtolower(substr(strrchr($dir_list[$i],"."),1));
          if (@$Lskip_ext[$file_extension])
          {         
            // do nothing file was not accepted [zip, rar, 7z, ...]!
            $skipped_files++;
          }
          else
          {
            $file_size = filesize($file_entry);  
            if ( ($file_size<20480000) && ($file_size>0) ){
              $fp        = fopen($file_entry,'r');
              $raw_data  = fread($fp,$file_size);
              fclose($fp);         
              $media_md5 = md5($raw_data);
              if (is_unformated_d64($media_md5)) {$imported_unformated++;}
              if (!$DB->media_md5_exist($media_md5)){
                $c64_object = new c64file($file_entry, $raw_data, false);         
                if ($c64_object->format_supported==true){
                  $DB->add_media($coll_id, $raw_data, $dir . $dir_list[$i], $c64_object, $os_id, $media_md5);
                  $imported_new_files++;
                } else {
                  $imported_new_files_not_supported++;
                }
              }
              else{
              # media exists => we have a c64 supported file => add it to DB.
                $DB->add_hyper_media($coll_id, $dir . $dir_list[$i], $media_md5);
                $imported_existing_files++;                
              }
                
              unset($raw_data);
              unset($c64_object); 
              unset($file_size);
              unset($fp);
              unset($file_extension);
              unset($file_entry);
            }
            else{
              // file was too big to be accepted
              $skipped_files++; 
            }
          }
        }
        else
        {
         # Unknown entry ( ? )
         if (SHOW_DEBUG) {echo "Function import_module.php::traversedir()->unknown dir_entry: ".$dir_entry;}
        }
      }
    } 
   }



# HTML HEADER
echo $html_begin;


echo "<fieldset style='width:600px;'><legend><b>Import</b></legend>";
echo "<i>-import new collections or update existing</i><br><br>";

if ( (($import_btn) OR ($update_btn))  AND ($coll_name))
{ 
    $Limport_list  = Array();
    $tid_start = getmicrotime();
    if ($coll_name=='*'){
        $dir_list = scandir(ARCHIVE_PATH);
        ignorecasesort($dir_list); 
        for ($i=0;$i<sizeOf($dir_list);$i++)
        {
          $dir_entry = $dir_list[$i];
          if ($dir_entry != "." && $dir_entry != ".."){
           if (is_dir(ARCHIVE_PATH . $dir_entry)){
              if ($DB->collection_name_exists($dir_entry."/")==0){ 
                $Limport_list[] = $dir_entry . "/";                
              } else {
                $Lupdate_list[] = $dir_entry . "/";                              
              }
            }
          }  
        } 
    }
    else{
      $Limport_list[] = $coll_name .= "/";
      $Lupdate_list[] = $coll_name ;
    }
    
    if ($update_btn) {$Limport_list = $Lupdate_list;}
        
    for ($i=0;$i<sizeOf($Limport_list);$i++){
      $path = ARCHIVE_PATH.$Limport_list[$i]; 
      if (is_dir($path))
      {      
        // Import / update a collection
        if ($coll_id = $DB->collection_name_exists($Limport_list[$i])){
          $DB->delete_collection($coll_id, TRUE);
        }
        else {
          $coll_id = $DB->add_collection($Limport_list[$i]);
        }
        echo "<br><b>Processing collection:<br> $Limport_list[$i], please wait...</b>";
        ob_flush();flush();
        traversedir($Limport_list[$i], $coll_id, $_REQUEST['sel_os']);        
        echo "<br>Total imported files:" . $DB->get_collection_size($coll_id) . '<br>';
        
        echo 'Total skipped files       : ' . $skipped_files . '<br>';
        echo 'Total new files           : ' . $imported_new_files . '<br>';
        echo 'Total existing files      : ' . $imported_existing_files . '<br>';
        echo 'Total unformated files    : ' . $imported_unformated . '<br>';
        echo 'Total files not supported : ' . $imported_new_files_not_supported . '<br>';
            
        ob_flush();flush();
      }
    }  
    
    $tid_slut = getmicrotime();
    echo "<p>Time spend: ".gmdate('H:i:s', ($tid_slut-$tid_start)), "<br><form action=import_module.php><input type=submit value='Ok'></form><hr>"; 
 }
 
else{
// default page
  $dir_list = scandir(ARCHIVE_PATH);
  ignorecasesort($dir_list); 

    echo "<form name='form_add_collection' action='import_module.php' method='post'>";
    $SQLos = $DB->get_operative_systems();    
    echo "<b>Operative System:</b><select name='sel_os'>";
    while ($row = mysql_fetch_array($SQLos, MYSQL_ASSOC)){
      echo "<option value='".$row['id']."'>".$row['name']."</option>";
    }
    echo "</select><br>";
    
    
    echo "<select name='sel_coll'>";
    echo "<option disabled value=''>Choose collection to import</option>";
    echo "<option value='*'>* Import all *</option>";
    for ($i=0;$i<sizeOf($dir_list);$i++)
    {
      $dir_entry = $dir_list[$i];
      if ($dir_entry != "." && $dir_entry != "..") 
      {
        if (is_dir(ARCHIVE_PATH . $dir_entry)) 
        {
          if ($DB->collection_name_exists($dir_entry."/")==0)
          { 
            echo "<option value=\"$dir_entry\">".$dir_entry."</option>";
          }
        }
      }  
     }
    echo "</select>";
    echo "<input type='submit' name='import_btn' value='Import'><br>";
  
    echo "<select name='sel_coll_upd'>";
    echo "<option disabled value=''>Choose collection to update</option>";
    echo "<option value='*'>* Update all *</option>";
    for ($i=0;$i<sizeOf($dir_list);$i++)
    {
      $dir_entry = $dir_list[$i];
      if ($dir_entry != "." && $dir_entry != "..") 
      {
        if (is_dir(ARCHIVE_PATH . $dir_entry)) 
        {
          if ($DB->collection_name_exists($dir_entry."/")<>0)
          { 
            echo "<option value=\"$dir_entry\">".$dir_entry."</option>";
          }
        }
      }  
     }
    echo "</select>";
    echo "<input type='submit' name='update_btn' value='Update'>";

    echo "<br></form>"; 
    echo "</fieldset>";

}
# HTML FOOTER
echo $html_end;
ob_end_flush();
?>
